#include <stdio.h>
#include <unistd.h>

#include "Objects.h"
#include "List/List.h"
#include "Building/Building.h"
#include "SharedData/SharedData.h"
#include "Visitor/Visitor.h"
#include "Resident/Resident.h"

void clean_exit(int error_code){
	printf("Signal %d received, exiting app\n", error_code);
	DELETE(GET_INSTANCE(SharedData));
	exit(0);
}

int main() {
	SharedData * shared_data = GET_INSTANCE(SharedData);

	signal(SIGINT, clean_exit);
	shared_data->set_main_building(shared_data, NEW(Building, "../residents.txt", "../visitors.txt"));
	shared_data->start_all_threads(shared_data);
	shared_data->wait_all_threads(shared_data);
	DELETE(shared_data);

	return 0;
}